SoRotateCylindricalDragger(3)

NAME
SoRotateCylindricalDragger - The SoRotateCylindricalDragger class is for rotating geometry around a single axis.

SYNOPSIS

#include <Inventor/draggers/SoRotateCylindricalDragger.h>

Inherits SoDragger.

  Public Member Functions
virtual SoType getTypeId (void) const
virtual const SoNodekitCatalog * getNodekitCatalog (void) const
SoRotateCylindricalDragger (void)
void setProjector (SbCylinderProjector *p)
const SbCylinderProjector * getProjector (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static const SoNodekitCatalog * getClassNodekitCatalog (void)
static void initClass (void)

  Public Attributes
SoSFRotation rotation

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoRotateCylindricalDragger (void)
virtual SbBool setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void copyContents (const SoFieldContainer *fromfc, SbBool copyconnections)
void dragStart (void)
void drag (void)
void dragFinish (void)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
static const SoNodekitCatalog ** getClassNodekitCatalogPtr (void)
static void startCB (void *f, SoDragger *d)
static void motionCB (void *f, SoDragger *d)
static void doneCB (void *f, SoDragger *d)
static void fieldSensorCB (void *f, SoSensor *s)
static void valueChangedCB (void *f, SoDragger *d)

  Protected Attributes
SoSFNode feedback
SoSFNode feedbackActive
SoSFNode feedbackSwitch
SoSFNode rotator
SoSFNode rotatorActive
SoSFNode rotatorSwitch
SoFieldSensor * fieldSensor
SbCylinderProjector * cylinderProj
SbBool userProj

  Additional Inherited Members

Detailed Description

The SoRotateCylindricalDragger class is for rotating geometry around a single axis. Here's how the dragger looks with its default geometry in the inactive state:

 Screen Shot of Default Dragger

Use an instance of this dragger class in your scene graph to let the end-users of your application rotate geometry around a predefined axis vector in 3D.

For the dragger orientation and positioning itself, use some kind of transformation node in your scene graph, as usual.

Constructor & Destructor Documentation

  SoRotateCylindricalDragger::SoRotateCylindricalDragger (void)
Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Nodekit structure (new entries versus parent class marked with arrow prefix):

CLASS SoRotateCylindricalDragger
-->'this'
      'callbackList'
      'topSeparator'
         'motionMatrix'
         'geomSeparator'
-->         'rotatorSwitch'
-->            'rotator'
-->            'rotatorActive'
-->         'feedbackSwitch'
-->            'feedback'
-->            'feedbackActive'

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

CLASS SoRotateCylindricalDragger
PVT   'this',  SoRotateCylindricalDragger  ---
      'callbackList',  SoNodeKitListPart [ SoCallback, SoEventCallback ]
PVT   'topSeparator',  SoSeparator  ---
PVT   'motionMatrix',  SoMatrixTransform  ---
PVT   'geomSeparator',  SoSeparator  ---
PVT   'rotatorSwitch',  SoSwitch  ---
      'rotator',  SoSeparator  ---
      'rotatorActive',  SoSeparator  ---
PVT   'feedbackSwitch',  SoSwitch  ---
      'feedback',  SoSeparator  ---
      'feedbackActive',  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

  SoRotateCylindricalDragger::~SoRotateCylindricalDragger (void) [protected], [virtual]
Protected destructor.

(Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

Member Function Documentation

  SoType SoRotateCylindricalDragger::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoRotateCylindricalDragger::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoDragger.

  const SoFieldData ** SoRotateCylindricalDragger::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoRotateCylindricalDragger::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoDragger.

  const SoNodekitCatalog * SoRotateCylindricalDragger::getClassNodekitCatalog (void) [static]
Returns the nodekit catalog which defines the layout of this class' kit.

  const SoNodekitCatalog * SoRotateCylindricalDragger::getNodekitCatalog (void) const [virtual]
Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoDragger.

  const SoNodekitCatalog ** SoRotateCylindricalDragger::getClassNodekitCatalogPtr (void) [static], [protected]
Returns the pointer to the pointer of the nodekit catalog for this class.

  void SoRotateCylindricalDragger::initClass (void) [static]
Initializes type system for this dragger class.

Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init().

  void SoRotateCylindricalDragger::setProjector (SbCylinderProjector * p)
Replace the default cylinder projection strategy. You may want to do this if you change the dragger geometry, for instance.

The default cylinder projection is an SbCylinderPlaneProjector.

See also
    SbCylinderSectionProjector, SbCylinderSheetProjector

  const SbCylinderProjector * SoRotateCylindricalDragger::getProjector (void) const
Returns projector instance used for converting from user interaction dragger movements to 3D dragger re-orientation.

See also
    setProjector()

  SbBool SoRotateCylindricalDragger::setUpConnections (SbBool onoff, SbBool doitalways = FALSE) [protected], [virtual]
Sets up all internal connections for instances of this class.

(This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.)

Reimplemented from SoInteractionKit.

  void SoRotateCylindricalDragger::copyContents (const SoFieldContainer * from, SbBool copyconnections) [protected], [virtual]
Makes a deep copy of all data of from into this instance, except external scene graph references if copyconnections is FALSE.

This is the method that should be overridden by extension node / engine / dragger / whatever subclasses which need to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to its parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
                                  SbBool copyconnections)
{
  // let parent superclasses do their thing (copy fields, copy
  // instance name, etc.)
  SoNode::copyContents(from, copyconnections);
  // [..then copy internal data..]
}

Reimplemented from SoInteractionKit.

  void SoRotateCylindricalDragger::startCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoRotateCylindricalDragger::motionCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoRotateCylindricalDragger::doneCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoRotateCylindricalDragger::fieldSensorCB (void * d, SoSensor * s) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoRotateCylindricalDragger::valueChangedCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoRotateCylindricalDragger::dragStart (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when dragger is selected (picked) by the user.

  void SoRotateCylindricalDragger::drag (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when user drags the mouse after picking the dragger.

  void SoRotateCylindricalDragger::dragFinish (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when mouse button is released after picking and interacting with the dragger.

Member Data Documentation

  SoSFRotation SoRotateCylindricalDragger::rotation
This field is continuously updated to contain the rotation of the current direction vector of the dragger.

The application programmer using this dragger in his scene graph should connect the relevant node fields in the scene to this field to make them follow the dragger orientation.

  SoFieldSensor * SoRotateCylindricalDragger::fieldSensor [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  SbCylinderProjector * SoRotateCylindricalDragger::cylinderProj [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  SbBool SoRotateCylindricalDragger::userProj [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Author

Generated automatically by Doxygen for Coin from the source code.